<?php

// h-admin, a web software to build a community of people that want to share their hardware information.
// Copyright (C) 2010  Antonio Gallo (h-admin-copyright.txt)
//
// This file is part of h-admin
//
// h-admin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// h-admin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with h-admin.  If not, see <http://www.gnu.org/licenses/>.

if (!defined('EG')) die('Direct access not allowed!');

class Website
{
	static public $generalMail = "";
	
	static public $generalName = "h-admin";
	
	static public $projectName = "h-admin";
	
	static public $mailServer = "";
	
	static public $mailPassword = "";
}

class Account
{
	
	static public $confirmTime = 3600;
	
	static public function confirm($username,$e_mail,$id_user,$token)
	{
		require_once (ROOT.'/External/swiftmailer/lib/swift_required.php');
		
		$clean['username'] = sanitizeAll($username);
		$clean['id_user'] = (int)$id_user;
		$clean['token'] = sanitizeAll($token);
		
		$siteName = Website::$generalName;
		$siteMail = Website::$generalMail;
		
		$mess = "Hello,\n\nyou have registered an account to $siteName with the following data:\nusername: ".$clean['username']."\n\nin order to confirm the registration of the new account follow the link below\nhttp://".DOMAIN_NAME."/users/confirm/".Lang::$current."/".$clean['id_user']."/".$clean['token']."\n\nIf you don't want to confirm the account registration\nthen wait one hour and your username and e-mail will be deleted from the database\n\nIf you received this e-mail for error, please simply disregard this message";
		
		$message = Swift_Message::newInstance()->setSubject('account registration to '.$siteName)->setFrom(array($siteMail => $siteName))->setTo(array($e_mail))->setBody($mess);

		//Create the Transport
		$transport = Swift_SmtpTransport::newInstance(Website::$mailServer, 25)->setUsername(Website::$generalMail)->setPassword(Website::$mailPassword);

		//Create the Mailer using your created Transport
		$mailer = Swift_Mailer::newInstance($transport);

		//Send the message
		$result = $mailer->send($message);

		if ($result)
		{
			return true;
		}
		else
		{
			return false;
		}

	}
	
	static public function sendnew($username,$e_mail,$id_user,$token)
	{
		require_once (ROOT.'/External/swiftmailer/lib/swift_required.php');
		
		$clean['username'] = sanitizeAll($username);
		$clean['id_user'] = (int)$id_user;
		$clean['token'] = sanitizeAll($token);
		
		$siteName = Website::$generalName;
		$siteMail = Website::$generalMail;
		
		$mess = "Hello,\n\nyou have requested a new password for your account at $siteName.\nYour username is:\n".$clean['username']."\n\nin order to obtain a new password for your account follow the link below\nhttp://".DOMAIN_NAME."/users/change/".Lang::$current."/".$clean['id_user']."/".$clean['token']."\n\nIf you don't want to change the password then disregard this mail\n";
		
		$message = Swift_Message::newInstance()->setSubject('request a new password at '.$siteName)->setFrom(array($siteMail => $siteName))->setTo(array($e_mail))->setBody($mess);

		//Create the Transport
		$transport = Swift_SmtpTransport::newInstance(Website::$mailServer, 25)->setUsername(Website::$generalMail)->setPassword(Website::$mailPassword);

		//Create the Mailer using your created Transport
		$mailer = Swift_Mailer::newInstance($transport);

		//Send the message
		$result = $mailer->send($message);

		if ($result)
		{
			return true;
		}
		else
		{
			return false;
		}
		
	}
	
	static public function sendpassword($username,$e_mail,$password)
	{
		require_once (ROOT.'/External/swiftmailer/lib/swift_required.php');
		
		$clean['username'] = sanitizeAll($username);
		$clean['password'] = sanitizeAll($password);
		
		$siteName = Website::$generalName;
		$siteMail = Website::$generalMail;
		
		$mess = "Hello,\n\nyou have requested a new password for your account to $siteName.\nYour username is:\n".$clean['username']."\n\nYour new password is:\n".$clean['password']."\n";
		
		$message = Swift_Message::newInstance()->setSubject('get your new h-node.com account password ')->setFrom(array($siteMail => $siteName))->setTo(array($e_mail))->setBody($mess);

		//Create the Transport
		$transport = Swift_SmtpTransport::newInstance(Website::$mailServer, 25)->setUsername(Website::$generalMail)->setPassword(Website::$mailPassword);

		//Create the Mailer using your created Transport
		$mailer = Swift_Mailer::newInstance($transport);

		//Send the message
		$result = $mailer->send($message);
		
		if ($result)
		{
			return true;
		}
		else
		{
			return false;
		}
		
	}
	
}